#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

int seconds = 11;
int seconds2 = 0;

ISR(TIMER1_COMPA_vect)
{
    seconds++;
    seconds2++;
}

void TIMER1_init()
{
    OCR1A = 62500;
    TIMSK1 |= (1 << OCIE1A);
    TCCR1B |= (1 << CS12);
}

int main()
{
    sei();
    int pwd1[4], pwd2[4];
    int pos, correct_password, try_number, wrong;
    wrong = 0;
    pos = 0;
    correct_password = 1;
    try_number = 0;
    DDRC |= _BV(PC2);
    PORTC |= _BV(PC2);
    LCD_init();
    TIMER1_init();
    DDRD &= ~_BV(PD0);
    DDRD &= ~_BV(PD1);
    DDRB &= ~_BV(PB0);
    DDRB &= ~_BV(PB1);
    DDRB &= ~_BV(PB2);
    DDRB &= ~_BV(PB3);
    DDRB &= ~_BV(PB4);
    DDRA &= ~_BV(PA0);
    DDRA &= ~_BV(PA1);
    DDRA &= ~_BV(PA2);
    DDRA &= ~_BV(PA3);
    DDRA &= ~_BV(PA4);
    PORTD |= (1 << PD0);
    PORTD |= (1 << PD1);
    PORTB |= (1 << PB0);
    PORTB |= (1 << PB1);
    PORTB |= (1 << PB2);
    PORTB |= (1 << PB3);
    PORTB |= (1 << PB4);
    PORTA |= (1 << PA0);
    PORTA |= (1 << PA1);
    PORTA |= (1 << PA2);
    PORTA |= (1 << PA3);
    PORTA |= (1 << PA4);

    while (1)
    {
        if (seconds > 10)
        {
            if (pos < 4 && try_number < 1)
            {
                LCD_printAt(0x40, "Alege o parola");
            }
            if (pos < 4 && try_number >= 1)
            {
                LCD_printAt(0x40, "Introdu parola");
            }
            if ((PINA & (1 << PA0)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "0");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");

                pwd2[pos] = 0;
                pos++;
                _delay_ms(300);
            }
            if ((PINA & (1 << PA1)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "1");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 1;
                pos++;
                _delay_ms(300);
            }
            if ((PINA & (1 << PA2)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "2");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 2;
                pos++;
                _delay_ms(300);
            }
            if ((PINA & (1 << PA3)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "3");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 3;
                pos++;
                _delay_ms(300);
            }
            if ((PINA & (1 << PA4)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "4");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 4;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB0)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "5");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 5;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB1)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "6");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 6;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB2)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "7");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 7;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB1)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "6");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 6;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB2)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "7");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 7;
                pos++;
                _delay_ms(300);
            }
            if ((PIND & (1 << PD0)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "8");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 8;
                pos++;
                _delay_ms(300);
            }
            if ((PIND & (1 << PD1)) == 0 && pos != 4)
            {
                LCD_printAt(pos, "9");
                if (pos != 0)
                    LCD_printAt(pos - 1, "*");
                pwd2[pos] = 9;
                pos++;
                _delay_ms(300);
            }
            if ((PINB & (1 << PB4)) == 0)
            {
                pos--;
                LCD_printAt(pos, " ");
                pwd2[pos] = -1;
                _delay_ms(300);
            }

            if (pos == 4 && (PINB & (1 << PB3)) == 0)
            {
                LCD_printAt(pos - 1, "*");
                wrong = 0;
                pos = 0;
                try_number++;
                if (try_number <= 1)
                {
                    for (int i = 0; i < 4; i++)
                        pwd1[i] = pwd2[i];
                    LCD_writeInstr(LCD_INSTR_clearDisplay);
                    LCD_printAt(0x40, "Usa inchisa");
                    _delay_ms(750);
                    LCD_writeInstr(LCD_INSTR_clearDisplay);
                    _delay_ms(200);
                }
                else
                {
                    for (int i = 0; i < 4; i++)
                        if (pwd2[i] != pwd1[i])
                            correct_password = 0;

                    if (correct_password == 0 && try_number == 4)
                    {
                        wrong = 1;
                        DDRD |= _BV(PD4);
                        DDRD |= _BV(PD5);
                        seconds2 = 0;
                        while (seconds2 <= 10)
                        {
                            LCD_writeInstr(LCD_INSTR_clearDisplay);
                            LCD_printAt(0x40, "Esti un hot");
                            PORTD |= (1 << PD4);
                            PORTD |= _BV(PD5);
                            _delay_ms(300);
                            PORTD &= ~(1 << PD5);
                            _delay_ms(300);
                        }
                        PORTD &= ~(1 << PD4);
                        seconds = 0;
                    }
                    if (correct_password != 0)
                    {
                        LCD_writeInstr(LCD_INSTR_clearDisplay);
                        LCD_printAt(0x40, "Usa deschisa");
                        DDRD |= _BV(PD5);
                        DDRD |= _BV(PD4);
                        PORTD |= (1 << PD4);
                        PORTD |= _BV(PD5);
                        _delay_ms(50);
                        PORTD &= ~(1 << PD4);
                        _delay_ms(50);
                        PORTD |= (1 << PD4);
                        PORTD &= ~(1 << PD5);
                        _delay_ms(50);
                        PORTD &= ~(1 << PD4);
                        _delay_ms(1000);
                        seconds = 0;
                    }
                    if (try_number != 4 && correct_password == 0)
                    {
                        correct_password = 1;
                        LCD_printAt(0x40, "Parola gresita");
                        _delay_ms(600);
                        LCD_writeInstr(LCD_INSTR_clearDisplay);
                        _delay_ms(300);
                    }
                }
            }
        }
        else
        {
            LCD_writeInstr(LCD_INSTR_clearDisplay);
            try_number = 0;
            pos = 0;
            correct_password = 1;
            if (wrong)
                try_number = 1;
        }
    }

    return 0;
}